#pragma once
#include <bitset>
#include "afxwin.h"
using namespace std;

#define TOTAL_GPIO_PIN	16
#define TOTAL_GPIO_PIN_IN 8

// CPropSetDlg dialog

class CPropSetDlg : public CDialogEx
{
	typedef enum {START, STOP, TEST} WDT_ACTION;

	DECLARE_DYNAMIC(CPropSetDlg)

public:
	CPropSetDlg(CComPtr<IKsPropertySet> pPropSet = NULL);   // standard constructor
	virtual ~CPropSetDlg();

	CComPtr<IKsPropertySet> m_pPropSet;

	BOOL m_bCkGpioPin[TOTAL_GPIO_PIN];
	bitset<TOTAL_GPIO_PIN / 2> m_GpioInStatus;
	bitset<TOTAL_GPIO_PIN / 2> m_GpioOutStatus;

// Dialog Data
	enum { IDD = IDD_GPIO_DIALOG };

protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

	DECLARE_MESSAGE_MAP()
public:
	afx_msg void OnBnClickedGetIdBtn();
	afx_msg void OnBnClickedGetBtn();
	void OnWDT(UINT uID);
	void OnSetOutPin(UINT uID);
	virtual BOOL OnInitDialog();

private:
	bool InitializeGPIO();
	bool GetGPIOData(WORD* data);
	bool SetGPIOData(WORD data);
	bool GetPICData(BYTE* byData);
	bool SetWDT(BYTE byData);
public:
	afx_msg void OnTimer(UINT_PTR nIDEvent);

	void UpdateGPIOStatus();
	void UpdateProtectedId();
	CStatic m_Status;
	CStatic m_PicId;
	int m_iWdtStatus;
};
